
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MachinesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.create(
            {
                id: data.id || undefined,
        
        asset_tag: data.asset_tag
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        manufacturer: data.manufacturer
        ||
        null
            ,
            
        model: data.model
        ||
        null
            ,
            
        serial_number: data.serial_number
        ||
        null
            ,
            
        commissioned_at: data.commissioned_at
        ||
        null
            ,
            
        last_service_at: data.last_service_at
        ||
        null
            ,
            
        hour_meter: data.hour_meter
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await machines.setWork_center( data.work_center || null, {
            transaction,
        });
        

        

        

        return machines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const machinesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                asset_tag: item.asset_tag
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                manufacturer: item.manufacturer
            ||
            null
            ,
            
                model: item.model
            ||
            null
            ,
            
                serial_number: item.serial_number
            ||
            null
            ,
            
                commissioned_at: item.commissioned_at
            ||
            null
            ,
            
                last_service_at: item.last_service_at
            ||
            null
            ,
            
                hour_meter: item.hour_meter
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const machines = await db.machines.bulkCreate(machinesData, { transaction });

        // For each item created, replace relation files
        

        return machines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const machines = await db.machines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.asset_tag !== undefined) updatePayload.asset_tag = data.asset_tag;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.manufacturer !== undefined) updatePayload.manufacturer = data.manufacturer;
        
        
        if (data.model !== undefined) updatePayload.model = data.model;
        
        
        if (data.serial_number !== undefined) updatePayload.serial_number = data.serial_number;
        
        
        if (data.commissioned_at !== undefined) updatePayload.commissioned_at = data.commissioned_at;
        
        
        if (data.last_service_at !== undefined) updatePayload.last_service_at = data.last_service_at;
        
        
        if (data.hour_meter !== undefined) updatePayload.hour_meter = data.hour_meter;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await machines.update(updatePayload, {transaction});

        
        
        if (data.work_center !== undefined) {
            await machines.setWork_center(
              
              data.work_center,
              
              { transaction }
            );
        }
        

        
        

        

        return machines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of machines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of machines) {
                await record.destroy({transaction});
            }
        });


        return machines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.findByPk(id, options);

        await machines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await machines.destroy({
            transaction
        });

        return machines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const machines = await db.machines.findOne(
            { where },
            { transaction },
        );

        if (!machines) {
            return machines;
        }

        const output = machines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.production_operations_machine = await machines.getProduction_operations_machine({
            transaction
        });
        
        
        
        
        
        
        
        
        output.maintenance_work_orders_machine = await machines.getMaintenance_work_orders_machine({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.work_center = await machines.getWork_center({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.work_centers,
        as: 'work_center',
        
        where: filter.work_center ? {
          [Op.or]: [
            { id: { [Op.in]: filter.work_center.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.work_center.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.asset_tag) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'asset_tag',
                        filter.asset_tag,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.manufacturer) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'manufacturer',
                        filter.manufacturer,
                    ),
                };
            }
            
            if (filter.model) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'model',
                        filter.model,
                    ),
                };
            }
            
            if (filter.serial_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'serial_number',
                        filter.serial_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'machines',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.commissioned_atRange) {
                const [start, end] = filter.commissioned_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    commissioned_at: {
                    ...where.commissioned_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    commissioned_at: {
                    ...where.commissioned_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_service_atRange) {
                const [start, end] = filter.last_service_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_service_at: {
                    ...where.last_service_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_service_at: {
                    ...where.last_service_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.hour_meterRange) {
                const [start, end] = filter.hour_meterRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    hour_meter: {
                    ...where.hour_meter,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    hour_meter: {
                    ...where.hour_meter,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.machines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'machines',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.machines.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

